/*
 * des.h - data encryption standard header file
 *
 * author: hackbard@hackdaworld.dyndns.org
 *
 */

#ifndef DES_H
#define DES_H

#define DES_SUBKEYS 16
#define DES_INITIAL_KEY_LEN 56
#define DES_SUBKEY_LEN 48
#define DES_DATA_BLOCK_LEN 64
#define DES_SBOXES 8
#define DES_SBOX_LEN 64
#define DES_PBOX_LEN 32

#define MODE_CRYPT 1
#define MODE_DECRYPT 2
#define MODE_ECB 4
#define MODE_CBC 8

typedef unsigned char u8;

int des_encrypt(u8 *plain,u8 *crypted,u8 *key,int len,u8 mode);
int des_decrypt(u8 *crypted,u8 *plain,u8 *key,int len,u8 mode);

#endif /* DES_H */
