/*
 * test.c - test ciphers ...
 *
 * hackbard@hackdaworld.dyndns.org
 *
 */

#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include "des.h"


int main() {
 u8 plain[32];
 u8 crypted[32];
 u8 key[8];
 int fd,i;

 if((fd=open("/dev/urandom",O_RDONLY))<0) {
  puts("open urandom device failed!");
  return fd;
 }

 printf("des crypt/decrypt test:\n");
 printf("- generating simple/random key ...\n");
 // read(fd,key,8);
 memset(key,0x90,8);
 printf("key: ");
 for(i=0;i<8;i++) printf("%02x ",key[i]);
 puts("");

 memset(plain,0,32);
 // strcpy(plain,"allyouratmels ... :)");
 printf("encrypting '");
 for(i=0;i<32;i++) printf("%02x%c",plain[i],i==31?'\n':' ');
 
 printf("encrypting (ecb mode) ...\n");
 memset(crypted,0,32);
 des_encrypt(plain,crypted,key,32,MODE_ECB);
 printf("plain: ");
 for(i=0;i<32;i++) printf("%02x ",plain[i]);
 puts("");
 printf("crypted: ");
 for(i=0;i<32;i++) printf("%02x ",crypted[i]);
 puts("");
 printf("decrypting (ecb mode) ...\n");
 memset(plain,0,32);
 des_decrypt(crypted,plain,key,32,MODE_ECB);
 printf("crypted: ");
 for(i=0;i<32;i++) printf("%02x ",crypted[i]);
 puts("");
 printf("plain: ");
 for(i=0;i<32;i++) printf("%02x ",plain[i]);
 puts("");
 
 close(fd);

 puts("done :)");

 return 1;
}
